#ifndef __IFile_h__
#define __IFile_h__

class String;
class HeapData;
class ConstSimpleData;

class IFile
{
public:
    enum Mode {
        MODE_READ,
        MODE_WRITE,
        MODE_APPEND,
    };

    virtual void open( Mode mode ) = 0;
    virtual void write( const String &line ) = 0;
    virtual void write( const ConstSimpleData &data ) = 0;
    virtual String readLine() = 0;
    virtual void read( HeapData &buffer, unsigned maxReadSize ) = 0;

	virtual ~IFile() {}
};

#endif // __IFile_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
