#ifndef __T__SelectableSocketFactory_h__
#define __T__SelectableSocketFactory_h__

#include "ISelectableSocket.h"
#include "cxxtest/Mock.h"

class ISelector;
class ISocket;

namespace T
{
	ISelectableSocket *createSelectableSocket( ISocket &socket, ISelector &selector, ISelectableSocket::ISocketDataHandler &socketDataHandler );
	void discardSelectableSocket( ISelectableSocket *selectableSocket );
}

// ISelectableSocket *createSelectableSocket( int descriptor );
// void discardSelectableSocket( ISelectableSocket *selectableSocket );

CXXTEST_SUPPLY( createSelectableSocket,        /* => T::Base_AllocateIrp */
				ISelectableSocket *,           /* Return type            */
				createSelectableSocket,        /* Name of mock member    */
				( ISocket &socket, ISelector &selector, ISelectableSocket::ISocketDataHandler &socketDataHandler ),  /* Prototype              */
				T::createSelectableSocket,        /* Name of real function  */
				( socket, selector, socketDataHandler )       /* Parameter list         */ );

CXXTEST_SUPPLY_VOID( discardSelectableSocket,        /* => T::Base_AllocateIrp */
					 discardSelectableSocket,        /* Name of mock member    */
					 ( ISelectableSocket *selectableSocket ),  /* Prototype              */
					 T::discardSelectableSocket,        /* Name of real function  */
					 ( selectableSocket )            /* Parameter list         */ );

#endif // __T__SelectableSocketFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
