#ifndef __TestLog_h__
#define __TestLog_h__

#include <cxxtest/TestSuite.h>

#include "String.h"
#include "Vector.h"

class TestLog
{
public:
    static Vector<String> _log;

    static void log( const String &message )
    {
        _log.append( message );
    }

    static bool happened( const String &message )
    {
        return _log.exists( message );
    }

    static void clear()
    {
        _log.clear();
    }

    static String at( unsigned index )
    {
        return _log[index];
    }

    static bool preceded( const String &before, const String &after )
    {
        TS_ASSERT( happened( before ) );
        TS_ASSERT( happened( after ) );

        for ( unsigned i = 0; i < _log.size(); ++i )
        {
            if ( _log[i] == before )
            {
                return true;
            }
            if ( _log[i] == after )
            {
                return false;
            }
        }

        return true;
    }
};

#endif // __TestLog_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
