#include <cxxtest/TestSuite.h>

#include "Error.h"
#include "MockErrno.h"
#include "String.h"
#include "SortedList.h"

class SortedListTestSuite : public CxxTest::TestSuite
{
public:
    MockErrno *mockErrno;

    void setUp()
    {
        TS_ASSERT( mockErrno = new MockErrno );
    }

    void tearDown()
    {
        TS_ASSERT_THROWS_NOTHING( delete mockErrno );
    }

    void test_insert()
    {
        SortedList<unsigned> sortedList;

        sortedList.insert( 5 );
        sortedList.insert( 3 );
        sortedList.insert( 14 );
        sortedList.insert( 7 );

        TS_ASSERT_EQUALS( sortedList.size(), 4U );

        SortedList<unsigned>::iterator it = sortedList.begin();

        TS_ASSERT_EQUALS( *it, 3U );
        ++it;

        TS_ASSERT_EQUALS( *it, 5U );
        ++it;

        TS_ASSERT_EQUALS( *it, 7U );
        ++it;

        TS_ASSERT_EQUALS( *it, 14U );
        ++it;

        TS_ASSERT_EQUALS( it, sortedList.end() );
    }
};

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
