#ifndef __AutoSyncPointResolver_h__
#define __AutoSyncPointResolver_h__

#include "ISyncPointResolver.h"
#include "T/SyncPointResolverFactory.h"

class AutoSyncPointResolver
{
public:
	AutoSyncPointResolver( ISelector &selector, ISocket &socket )
	{
		_syncPointResolver = T::createSyncPointResolver( selector, socket );
	}

	~AutoSyncPointResolver()
	{
		T::discardSyncPointResolver( _syncPointResolver );
		_syncPointResolver = 0;
	}

	operator ISyncPointResolver &()
	{
		return *_syncPointResolver;
	}

	ISyncPointResolver *operator->()
	{
		return _syncPointResolver;
	}

	const ISyncPointResolver *operator->() const
	{
		return _syncPointResolver;
	}

private:
	ISyncPointResolver *_syncPointResolver;
};

#endif // __AutoSyncPointResolver_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
