#ifndef __IBThread_h__
#define __IBThread_h__

#include "IThreaded.h"
#include "String.h"
#include "Vector.h"

class AtomicPropositions;
class Event;

class IBThread : public IThreaded
{
public:
    enum {
        NO_TIMEOUT = 0,
        EVENT_TYPE_IF_EXPIRED = 0xFA12FA12,
    };

    enum SyncResult {
        TIMEOUT,
        EVENT_WAS_TRIGGERED,
    };

    virtual SyncResult bSync( const Vector<Event> &requested,
                              const Vector<Event> &watched,
                              const Vector<Event> &blocked,
                              unsigned timeout,
                              String label = "" ) = 0;

    virtual void done() = 0;

    virtual ~IBThread() {}
};

#endif // __IBThread_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
