#ifndef __IWeaver_h__
#define __IWeaver_h__

class Event;
class EventPredicate;
class IThreadListener;

#include "IServerSocket.h"
#include "Vector.h"

class IWeaver
{
public:
    virtual void bSync( IThreadListener *thread, const Vector<Event> &requested, const Vector<Event> &blocked ) = 0;
    virtual void bSync( IThreadListener *thread, const Vector<Event> &requested, EventPredicate *blockPredicate ) = 0;

    virtual void removeThread( IThreadListener *thread ) = 0;

    virtual ~IWeaver() {}

    virtual void acceptRegularThread( IThreadListener *threadListener ) = 0;
    virtual void acceptNonBlockingThread( IThreadListener *threadListener ) = 0;
};

#endif // __IWeaver_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
