#ifndef __NonBlockingThreadListener_h__
#define __NonBlockingThreadListener_h__

#include "AutoServerSocket.h"
#include "EngineConfiguration.h"
#include "INonBlockingThreadListener.h"
#include "IWeaver.h"
#include "T/ThreadListenerFactory.h"

class NonBlockingThreadListener : public INonBlockingThreadListener
{
public:
    NonBlockingThreadListener( ISelector &selector, IWeaver &weaver ) :
        _selector( selector ),
        _weaver( weaver ),
        _serverSocket( selector, EngineConfiguration::NON_BLOCKING_BTHREAD_MANAGEMENT_PORT, *this )
    {
    }

	void handleAcceptedSocket( ISocket &socket )
	{
        _weaver.acceptNonBlockingThread( T::createThreadListener( _weaver, _selector, socket ) );
    }

private:
    ISelector &_selector;
    IWeaver &_weaver;
    AutoServerSocket _serverSocket;
};

#endif // __NonBlockingThreadListener_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
