#ifndef __RegularThreadListener_h__
#define __RegularThreadListener_h__

#include "AutoServerSocket.h"
#include "EngineConfiguration.h"
#include "IRegularThreadListener.h"
#include "IWeaver.h"
#include "T/ThreadListenerFactory.h"

class RegularThreadListener : public IRegularThreadListener
{
public:
    RegularThreadListener( ISelector &selector, IWeaver &weaver ) :
        _selector( selector ),
        _weaver( weaver ),
        _serverSocket( selector, EngineConfiguration::BTHREAD_MANAGEMENT_PORT, *this )
    {
    }

	void handleAcceptedSocket( ISocket &socket )
	{
        _weaver.acceptRegularThread( T::createThreadListener( _weaver, _selector, socket ) );
    }

private:
    ISelector &_selector;
    IWeaver &_weaver;
    AutoServerSocket _serverSocket;
};

#endif // __RegularThreadListener_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
