#ifndef __T__RegularThreadListenerFactory_h__
#define __T__RegularThreadListenerFactory_h__

#include "cxxtest/Mock.h"

class IRegularThreadListener;
class ISelector;
class IWeaver;

namespace T
{
	IRegularThreadListener *createRegularThreadListener( ISelector &selector, IWeaver &weaver );
	void discardRegularThreadListener( IRegularThreadListener *regularThreadListener );
}

CXXTEST_SUPPLY( createRegularThreadListener,
				IRegularThreadListener *,
				createRegularThreadListener,
				( ISelector &selector, IWeaver &weaver ),
				T::createRegularThreadListener,
				( selector, weaver ) );

CXXTEST_SUPPLY_VOID( discardRegularThreadListener,
					 discardRegularThreadListener,
					 ( IRegularThreadListener *regularThreadListener ),
					 T::discardRegularThreadListener,
					 ( regularThreadListener ) );

#endif // __T__RegularThreadListenerFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
