#ifndef __MockNonBlockingThreadListenerFactory_h__
#define __MockNonBlockingThreadListenerFactory_h__

#include "MockNonBlockingThreadListener.h"
#include "T/NonBlockingThreadListenerFactory.h"

class MockNonBlockingThreadListenerFactory :
	public T::Base_createNonBlockingThreadListener,
	public T::Base_discardNonBlockingThreadListener
{
public:
	MockNonBlockingThreadListener mockNonBlockingThreadListener;

	~MockNonBlockingThreadListenerFactory()
	{
		if ( mockNonBlockingThreadListener.wasCreated )
		{
			TS_ASSERT( mockNonBlockingThreadListener.wasDiscarded );
		}
	}

	INonBlockingThreadListener *createNonBlockingThreadListener( ISelector &selector, IWeaver &weaver )
	{
		mockNonBlockingThreadListener.mockConstructor( selector, weaver );
		return &mockNonBlockingThreadListener;
	}

	void discardNonBlockingThreadListener( INonBlockingThreadListener *nonBlockingThreadListener )
	{
		TS_ASSERT_EQUALS( nonBlockingThreadListener, &mockNonBlockingThreadListener );
		mockNonBlockingThreadListener.mockDestructor();
	}
};

#endif // __MockNonBlockingThreadListenerFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
