#ifndef __MockRegularThreadListenerFactory_h__
#define __MockRegularThreadListenerFactory_h__

#include "MockRegularThreadListener.h"
#include "T/RegularThreadListenerFactory.h"

class MockRegularThreadListenerFactory :
	public T::Base_createRegularThreadListener,
	public T::Base_discardRegularThreadListener
{
public:
	MockRegularThreadListener mockRegularThreadListener;

	~MockRegularThreadListenerFactory()
	{
		if ( mockRegularThreadListener.wasCreated )
		{
			TS_ASSERT( mockRegularThreadListener.wasDiscarded );
		}
	}

	IRegularThreadListener *createRegularThreadListener( ISelector &selector, IWeaver &weaver )
	{
		mockRegularThreadListener.mockConstructor( selector, weaver );
		return &mockRegularThreadListener;
	}

	void discardRegularThreadListener( IRegularThreadListener *regularThreadListener )
	{
		TS_ASSERT_EQUALS( regularThreadListener, &mockRegularThreadListener );
		mockRegularThreadListener.mockDestructor();
	}
};

#endif // __MockRegularThreadListenerFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
