#ifndef __BridgeToTcp_h__
#define __BridgeToTcp_h__

#include "BThread.h"
#include "IEvent.h"

class BridgeToTcp : public BThread
{
public:
    BridgeToTcp() : BThread( BThread::REGULAR_THREAD )
    {
    }

    void entryPoint()
    {
        try
        {
            while ( true )
            {
                waitForRequests();
                handleRequests();
            }
        }
        catch ( Error &e )
        {
            e.setUserMessage( "Thread: BridgeToTcp" );
            throw e;
        }
    }

private:
    void waitForRequests()
    {
        clearEventVectors();

        _watched.append( IEvent::DATA_FROM_HTTP_TO_TCP );
        _blocked.append( IEvent::TCP_SEND_PUSH );

        bSync( _requested, _watched, _blocked, IBThread::NO_TIMEOUT );
    }

    void handleRequests()
    {
        clearEventVectors();
        _requested.append( Event( IEvent::TCP_SEND_PUSH, lastEvent().payload() ) );
        _blocked.append( IEvent::DATA_FROM_HTTP_TO_TCP );
        bSync( _requested, _watched, _blocked, IBThread::NO_TIMEOUT );
    }
};

#endif // __BridgeToTcp_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
